VERSION 5.00
Begin VB.UserControl ActionButton 
   ClientHeight    =   420
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5520
   LockControls    =   -1  'True
   ScaleHeight     =   420
   ScaleWidth      =   5520
   ToolboxBitmap   =   "ActionButton.ctx":0000
   Begin VB.CommandButton cmdControls 
      Caption         =   "&Save"
      Height          =   330
      Index           =   1
      Left            =   1365
      TabIndex        =   3
      Top             =   45
      Width           =   1290
   End
   Begin VB.CommandButton cmdControls 
      Caption         =   "&Delete"
      Height          =   330
      Index           =   2
      Left            =   2745
      TabIndex        =   2
      Top             =   45
      Width           =   1290
   End
   Begin VB.CommandButton cmdControls 
      Caption         =   "&Close"
      CausesValidation=   0   'False
      Height          =   330
      Index           =   3
      Left            =   4110
      TabIndex        =   1
      Top             =   45
      Width           =   1290
   End
   Begin VB.CommandButton cmdControls 
      Caption         =   "&New"
      CausesValidation=   0   'False
      Height          =   330
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   45
      Width           =   1290
   End
End
Attribute VB_Name = "ActionButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------------------------------------------------------------------------------
'   File Name: ActionButton.ctl
'
'   Description: This file is used for keeping in forms where database operation is taking place
'                This control should be used with Extended TextBox Control written by Sreekumar
'                This will Do all validate for controls placed inside the form and will generate
'                field names and values required for insert queries in a comma separated fashion
'   All rights reserved.
'
'   Revision History:
'   1)  Originally created  :   09/14/2001
'   2)  Last Updated        :   09/15/2001
'----------------------------------------------------------------------------------------

    Event CloseClick()
    Event DeleteClick()
    Event SaveClick(strFieldNames As String, strInsertValues As String)
    Event NewClick()
    
    Dim bDoDb                   As Boolean
    Dim strFieldNames           As String
    Dim strInsertValue          As String
    Dim s_DBOperation           As DBOp
    Dim s_RequireValidation     As Boolean
    Dim s_GenerateQuery         As Boolean
    Dim intctlCount             As Integer
    
    Enum DBOp
        Insert = 1
        Update = 2
        Delete = 3
    End Enum

'----------------------------------------------------------------------------------------
'   Function Name:  UserControl_ReadProperties(PropBag As PropertyBag)
'
'   Remarks:        This will initialise values for the variables used in th eocx
'----------------------------------------------------------------------------------------
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    bDoDb = PropBag.ReadProperty("CanDoInsertUpdate", False)
    s_DBOperation = PropBag.ReadProperty("DBOperation", Insert)
    s_RequireValidation = PropBag.ReadProperty("RequireValidation", True)
    s_GenerateQuery = PropBag.ReadProperty("GenerateQuery", False)
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  UserControl_Resize()
'
'   Remarks:        This will resize the command buttons placed in the OCX
'----------------------------------------------------------------------------------------
Private Sub UserControl_Resize()
On Error GoTo errNest
    Dim intwidth    As Integer
    Dim intCounter  As Integer
    intwidth = Int(UserControl.Width / 4)
    
    For intCounter = 0 To 3
        cmdControls(intCounter).Width = intwidth
        cmdControls(intCounter).Height = UserControl.Height - 80
        If Not intCounter + 1 > 3 Then
            cmdControls(intCounter + 1).Left = cmdControls(intCounter).Left + cmdControls(intCounter).Width + 30
        End If
    Next
        cmdControls(3).Width = cmdControls(3).Width - 90
    Exit Sub
errNest:
    MsgBox Err.Description, vbExclamation, "Error Occured"
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  cmdControls_Click(Index As Integer)
'
'   Remarks:        This will trigger respective events and validate entries made and will
'                   generate insert field names and values
'----------------------------------------------------------------------------------------
Private Sub cmdControls_Click(Index As Integer)
    If Index = 0 Then
        Call sClearControls
        RaiseEvent NewClick
    ElseIf Index = 1 Then
        'validating entries made and generating field names and values
        If RequireValidation = True Then
            Call sDoValidation
        End If
        'raising save event
        RaiseEvent SaveClick(strFieldNames, strInsertValue)
    ElseIf Index = 2 Then
        'raising DeleteClick
        RaiseEvent DeleteClick
    ElseIf Index = 3 Then
       'raising CloseClick
        RaiseEvent CloseClick
    End If
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  CanDoInsertUpdate(bDoDbOperation As Boolean)
'
'   Remarks:        Setting property which is used to know whether updation or insert can be done
'----------------------------------------------------------------------------------------
Public Property Let CanDoInsertUpdate(bDoDbOperation As Boolean)
    bDoDb = bDoDbOperation
    PropertyChanged "CanDoInsertUpdate"
End Property
'----------------------------------------------------------------------------------------
'   Function Name:  CanDoInsertUpdate()Boolean
'
'   Remarks:        Setting property which is used to know whether updation or insert can be done
'----------------------------------------------------------------------------------------
Public Property Get CanDoInsertUpdate() As Boolean
    CanDoInsertUpdate = bDoDb
End Property
'----------------------------------------------------------------------------------------
'   Function Name:  sDoValidation
'
'   Remarks:        Validating all the entries made in controls in the form and generating
'                   Insert field names and values in comma separated format
'----------------------------------------------------------------------------------------
Private Sub sDoValidation()
    On Error GoTo errNest
    strFieldNames = ""
    strInsertValue = ""
    For intctlCount = 0 To UserControl.ParentControls.Count - 1
        'if type of the control is extended text box
        If TypeName(UserControl.ParentControls(intctlCount)) = "TextBoxControl" Then
           If GenerateQuery = True Then
                'generating field names and insert values
                sGenerateFieldNames UserControl.ParentControls(intctlCount)
           End If
           'if the required property of extended text box is  true (mandatory )
           If UserControl.ParentControls(intctlCount).required = True Then
              If Trim(UserControl.ParentControls(intctlCount).Text) = "" Then
                 MsgBox "Null Entry not permitted !", vbExclamation, "Data Entry Error"
                 CanDoInsertUpdate = False
                 UserControl.ParentControls(intctlCount).SetFocus
                 Exit Sub
              Else
                CanDoInsertUpdate = True
              End If
           End If
        'if the type of control is mask edit box then validate for date entries
        ElseIf TypeName(UserControl.ParentControls(intctlCount)) = "MaskEdBox" Then
            If UserControl.ParentControls(intctlCount).Tag <> "" Then
               If GenerateQuery = True Then
                'generating field names and insert values
                sGenerateFieldNames UserControl.ParentControls(intctlCount)
               End If
               If Not IsDate(UserControl.ParentControls(intctlCount).Text) Then
                  MsgBox "Invalid Date Entry !", vbExclamation, "Data Entry Error"
                  CanDoInsertUpdate = False
                  UserControl.ParentControls(intctlCount).SetFocus
                  Exit Sub
               Else
                  CanDoInsertUpdate = True
               End If
            End If
        Else
            If UserControl.ParentControls(intctlCount).Tag <> "" Then
               If GenerateQuery = True Then
                'generating field names and insert values
                sGenerateFieldNames UserControl.ParentControls(intctlCount)
               End If
               If Trim(UserControl.ParentControls(intctlCount).Text) = "" Then
                    MsgBox "Null Entry not permitted !", vbExclamation, "Data Entry Error"
                    CanDoInsertUpdate = False
                    UserControl.ParentControls(intctlCount).SetFocus
                    Exit Sub
               Else
                    CanDoInsertUpdate = True
               End If
            End If
        End If
    Next
    Exit Sub
errNest:
        MsgBox Err.Description, vbExclamation, "Error Occured"
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  UserControl_WriteProperties(PropBag As PropertyBag)
'
'   Remarks:        writing proeprties to the ocx
'----------------------------------------------------------------------------------------
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("CanDoInsertUpdate", bDoDb, False)
    Call PropBag.WriteProperty("DBOperation", s_DBOperation, 1)
    Call PropBag.WriteProperty("RequireValidation", s_RequireValidation, True)
    Call PropBag.WriteProperty("GenerateQuery", s_GenerateQuery, False)
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  sGenerateFieldNames(ctlName As Control)
'
'   Remarks:        generating field names and values
'----------------------------------------------------------------------------------------
Private Sub sGenerateFieldNames(ctlName As Control)
On Error GoTo errNest
    Dim CtlValue As String
    If s_DBOperation = Insert Then
        If ctlName.Tag <> "" Then
           strFieldNames = IIf((strFieldNames = ""), ctlName.Tag, strFieldNames & "," & ctlName.Tag)
           If TypeName(ctlName) = "TextBoxControl" Then
                If ctlName.datatype = 1 Then
                   strInsertValue = IIf((strInsertValue = ""), Val(ctlName.Text), strInsertValue & "," & Val(ctlName.Text))
                ElseIf ctlName.datatype = 2 Or ctlName.datatype = 3 Then
                   CtlValue = Trim(sReplaceQuotes(ctlName.Text))
                   strInsertValue = IIf((strInsertValue = ""), "'" & CtlValue & "'", strInsertValue & ",'" & CtlValue & "'")
                End If
            Else
                   CtlValue = Trim(sReplaceQuotes(ctlName.Text))
                   strInsertValue = IIf((strInsertValue = ""), "'" & CtlValue & "'", strInsertValue & ",'" & CtlValue & "'")
            End If
        End If
    ElseIf s_DBOperation = Update Then
       If ctlName.Tag <> "" Then
            strFieldNames = IIf((strFieldNames = ""), ctlName.Tag, strFieldNames & "," & ctlName.Tag)
            If TypeName(ctlName) = "TextBoxControl" Then
                 If ctlName.datatype = 1 Then
                    strInsertValue = IIf((strInsertValue = ""), ctlName.Tag & "=" & Val(ctlName.Text), strInsertValue & "," & ctlName.Tag & "=" & Val(ctlName.Text))
                 ElseIf ctlName.datatype = 2 Or ctlName.datatype = 3 Then
                    CtlValue = Trim(sReplaceQuotes(ctlName.Text))
                    strInsertValue = IIf((strInsertValue = ""), ctlName.Tag & "='" & CtlValue & "'", strInsertValue & "," & ctlName.Tag & "='" & CtlValue & "'")
                 End If
             Else
                    CtlValue = Trim(sReplaceQuotes(ctlName.Text))
                    strInsertValue = IIf((strInsertValue = ""), ctlName.Tag & "='" & CtlValue & "'", strInsertValue & "," & ctlName.Tag & "='" & CtlValue & "'")
             End If
        End If
    End If
Exit Sub
errNest:
    MsgBox Err.Description, vbExclamation, "Error Occured"
End Sub
'----------------------------------------------------------------------------------------
'   Function Name:  DBOperation(m_dbOperation As DBOp)
'
'   Remarks:        property to set the flag as Insert,Delete,Update
'----------------------------------------------------------------------------------------
Public Property Let DBOperation(m_dbOperation As DBOp)
    s_DBOperation = m_dbOperation
    PropertyChanged "DBOperation"
End Property
'----------------------------------------------------------------------------------------
'   Function Name:  DBOperation(m_dbOperation As DBOp)
'
'   Remarks:        property to get the flag as Insert,Delete,Update
'----------------------------------------------------------------------------------------
Public Property Get DBOperation() As DBOp
    DBOperation = s_DBOperation
End Property
'----------------------------------------------------------------------------------------
'   Function Name:  sClearControls
'
'   Remarks:        Clearing controls
'----------------------------------------------------------------------------------------
Private Sub sClearControls()
    On Error GoTo errNest
    For intctlCount = 0 To UserControl.ParentControls.Count - 1
        If TypeName(UserControl.ParentControls(intctlCount)) = "TextBoxControl" Then
           If UserControl.ParentControls(intctlCount).Tag <> "" Then
              UserControl.ParentControls(intctlCount).Text = ""
           End If
        ElseIf TypeName(UserControl.ParentControls(intctlCount)) = "MaskEdBox" Then
            UserControl.ParentControls(intctlCount).Text = "__/__/____"
        End If
    Next intctlCount
    Exit Sub
errNest:
    MsgBox Err.Description, vbExclamation, "Error Occured"
End Sub

'---------------------------------------------------------------------------------------
' Procedure : sReplaceQuotes
' DateTime  : 16/11/2001 16:08
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Private Function sReplaceQuotes(strText As String) As String
    sReplaceQuotes = Replace(strText, "'", "''")
End Function
'---------------------------------------------------------------------------------------
' Procedure : ClearControls
' DateTime  : 16/11/2001 16:08
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Public Sub ClearControls()
    Call sClearControls
End Sub
'---------------------------------------------------------------------------------------
' Procedure : RequireValidation
' DateTime  : 16/11/2001 16:08
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Public Property Let RequireValidation(m_RequireValidation As Boolean)
    s_RequireValidation = m_RequireValidation
    PropertyChanged "RequireValidation"
End Property
'---------------------------------------------------------------------------------------
' Procedure : RequireValidation
' DateTime  : 16/11/2001 16:09
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Public Property Get RequireValidation() As Boolean
    RequireValidation = s_RequireValidation
End Property
'---------------------------------------------------------------------------------------
' Procedure : GenerateQuery
' DateTime  : 16/11/2001 16:09
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Public Property Let GenerateQuery(m_GenerateQuery As Boolean)
    s_GenerateQuery = m_GenerateQuery
    PropertyChanged "GenerateQuery"
End Property
'---------------------------------------------------------------------------------------
' Procedure : GenerateQuery
' DateTime  : 16/11/2001 16:09
' Author    : sreekumar
' Purpose   :
'---------------------------------------------------------------------------------------
Public Property Get GenerateQuery() As Boolean
    GenerateQuery = s_GenerateQuery
End Property

